package net.t2code.t2codelib.SPIGOT.api.messages;

import net.kyori.adventure.platform.bukkit.BukkitAudiences;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.minimessage.MiniMessage;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class T2C_MiniMessage {
    private static final BukkitAudiences bukkitAudiences = T2C_Main.getPlugin().getAdventure();

    public static void sendSenderMiniMessage(String msg, CommandSender sender) {
        String string = "";
        if (sender instanceof Player) {
            Player player = (Player) sender;
            string = T2C_Replace.replace("",player,msg);
        } else string = msg;
        bukkitAudiences.sender(sender).sendMessage(replace(string));
    }

    public static void sendConsoleMiniMessage(String msg) {
        bukkitAudiences.console().sendMessage(replace(msg));
    }

    public static void sendPlayerMiniMessage(String msg, Player player) {
        bukkitAudiences.player(player).sendMessage(replace(T2C_Replace.replace("", player, msg)));
    }

    protected static Component replace(String text) {
        return MiniMessage.miniMessage().deserialize(T2C_Replace.convertColorCode(text));
    }


    public static String removeMiniMessageCodes(String text){
        return MiniMessage.miniMessage().stripTags(text);
    }
}
