package net.t2code.t2codelib.SPIGOT.system;

import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import net.t2code.t2codelib.util.T2C_Util;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Arrays;

public class T2C_ProxyCommandSenderReceiver {

    public static void sendToBungee(CommandSender sender, String information, Boolean console) {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            if (console) {
                output.writeUTF("T2Code-Console");
            } else {
                if (sender instanceof Player) {
                    output.writeUTF(sender.getName());
                } else {
                    output.writeUTF("T2Code-Console");
                }
            }
            output.writeUTF(information);
            output.writeUTF(String.valueOf(T2C_LibConfig.VALUES.serverUUID.getValue()));
        } catch (IOException e) {
            T2C_Send.sendException(e, T2C_Main.getPlugin().getLogger());
        }
        if (sender instanceof Player) {
            Player player = (Player) sender;
            player.sendPluginMessage(T2C_Main.getPlugin(), T2C_Util.getPluginChannel_ProxyCommand(), stream.toByteArray());
            T2C_Debug.debug(T2C_Main.getPlugin(), "PluginMessage received T2CbungeeCommandSenderReciver: "+ T2C_Util.getPluginChannel_ProxyCommand()+" - " + Arrays.toString(stream.toByteArray()) + " Player: " + player.getName());
        } else {
            for (Player player : Bukkit.getOnlinePlayers()) {
                player.sendPluginMessage(T2C_Main.getPlugin(), T2C_Util.getPluginChannel_ProxyCommand(), stream.toByteArray());
                T2C_Debug.debug(T2C_Main.getPlugin(), "PluginMessage received T2CbungeeCommandSenderReciver: "+ T2C_Util.getPluginChannel_ProxyCommand()+" - " + Arrays.toString(stream.toByteArray()) + " Player: " + player.getName());
                return;
            }
        }
    }
}
